routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Route::get('/datatable1', function () {
    return view('datatable1');
})->name('datatable1');
Route::get('/datatable2', function () {
    return view('datatable2');
})->name('datatable2');
Route::get('/datatable3', function () {
    return view('datatable3');
})->name('datatable3');
Route::post('/allPosts', 'PostController@allPosts')->name('allPosts');
Route::resource('posts', 'PostController');

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    public $timestamps = false;
    protected $fillable = ['title', 'body'];
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;

class PostController extends Controller
{
    public function allPosts(Request $request)
    {
        $columns = array(
            0 => 'id',
            1 => 'title',
            2 => 'body',
            4 => 'id',
        );

        $totalData = Post::count();

        $totalFiltered = $totalData;

        $limit = $request->input('length');
        $start = $request->input('start');
        $order = $columns[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir');

        if (empty($request->input('search.value'))) {
            $posts = Post::offset($start)
                ->limit($limit)
                ->orderBy($order, $dir)
                ->get();
        } else {
            $search = $request->input('search.value');

            $posts =  Post::where('id', 'LIKE', "%{$search}%")
                ->orWhere('title', 'LIKE', "%{$search}%")
                ->offset($start)
                ->limit($limit)
                ->orderBy($order, $dir)
                ->get();

            $totalFiltered = Post::where('id', 'LIKE', "%{$search}%")
                ->orWhere('title', 'LIKE', "%{$search}%")
                ->count();
        }

        $data = array();
        if (!empty($posts)) {
            foreach ($posts as $post) {
                $show =  route('posts.show', $post);
                $edit =  route('posts.edit', $post);
                $delete =  route('posts.destroy', $post->id);

                $nestedData['id'] = $post->id;
                $nestedData['title'] = $post->title;
                $nestedData['body'] = substr(strip_tags($post->body), 0, 50);
                $nestedData['options'] = "&emsp;<a href='{$show}' title='SHOW' class='btn btn-primary' >SHOW</a>
                          &emsp;<a href='{$edit}' title='EDIT' class='btn btn-secondary'>EDIT</a>&emsp;
                          <form action='{$delete}' method='POST' style='display:inline'>
                          <input type='hidden' name='_token' id='csrf-token' value=" . Session::token() . " />
                          <input type='hidden' name='_method' value='delete'>
                          <input onclick='return confirm(`confirm ?`);' type='submit' value='Delete' class='btn btn-danger'>
                        </form>";
                $data[] = $nestedData;
            }
        }

        $json_data = array(
            "draw"            => intval($request->input('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );

        echo json_encode($json_data);
    }

    public function show(Post $post)
    {
        return view('show', compact('post'));
    }

    public function edit(Post $post)
    {
        return view('edit', compact('post'));
    }

    public function update(Request $request, Post $post)
    {
        // dd($post);
        $post->update([
            'title' => $request->title,
            'body' => $request->body,
        ]);
        return view('datatable3');
    }

    public function destroy($id)
    {
        Post::where('id', $id)->delete();
        return redirect()->back();
    }
}

resources/views/datatable1.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
    <table id="datatable1" class="table table-striped table-bordered" cellspacing="0" width="100%">
        <thead>
            <tr>
                <th>Column 1</th>
                <th>Column 2</th>
                <th>Column 3</th>
                <th>Column 4</th>
                <th>Column 5</th>
            </tr>
        </thead>
        <tbody>
            @for ($i = 0; $i < 100; $i++) <tr>
                <td>Row {{ $i }} Data 1</td>
                <td>Row {{ $i }} Data 2</td>
                <td>Row {{ $i }} Data 3</td>
                <td>Row {{ $i }} Data 4</td>
                <td>Row {{ $i }} Data 5</td>
                </tr>
                @endfor
        </tbody>
    </table>
</div>
<script>
    $(document).ready( function () {
        $('#datatable1').DataTable();
    });
</script>

@endsection

resources/views/datatable2.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
    <table id="datatable1" class="table table-striped table-bordered" cellspacing="0" width="100%">
        <thead>
            <tr>
                <th>id</th>
                <th>name</th>
                <th>username</th>
                <th>email</th>
            </tr>
        </thead>
    </table>
</div>
<script>
    $(document).ready( function () {
        $('#datatable1').DataTable({
            "ajax" : { "url": "http://jsonplaceholder.typicode.com/users", "dataSrc": ""},
            columns : [
            { "data" : "id"},
            { "data" : "name"},
            { "data" : "username"},
            { "data" : "email"}
            ]
        });
    });
</script>

@endsection

resources/views/datatable3.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
    <table id="datatable1" class="table table-striped table-bordered" cellspacing="0" width="100%">
        <thead>
            <th>Id</th>
            <th>Title</th>
            <th>Body</th>
            <th>Options</th>
        </thead>
    </table>
</div>
<script>
    $(document).ready( function () {
        $('#datatable1').DataTable({
            "processing": true,
            "serverSide": true,
            "ajax":{
                     "url": "{{ url('allPosts') }}",
                     "dataType": "json",
                     "type": "POST",
                     "data":{ _token: "{{csrf_token()}}"}
                   },
            "columns": [
                { "data": "id" },
                { "data": "title" },
                { "data": "body" },
                { "data": "options" ,'searchable':false, 'orderable':false}
            ]	 
        });
    });
</script>

@endsection

resources/views/edit.blade.php
@extends('layouts.app')

@section('content')
<form action="{{route('posts.update',$post)}}" method="post">
    @csrf
    @method('put')
    <div class="card" style="width: 18rem;">
        <div class="card-header">
            <input type="text" value=" {{ $post['title'] }}" name="title">
        </div>
        <ul class="list-group list-group-flush">
            <input type="text" value=" {{ $post['body'] }}" name="body" style="padding: 5px">
        </ul>
        <br>
        <input type="submit" value="Update" class="btn btn-primary">
    </div>
</form>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="x-ua-compatible" content="ie=edge">

    <title>{{ config('app.name', 'Datatables') }}</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
        integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">

    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.21/css/jquery.dataTables.css">
    <script src="https://code.jquery.com/jquery-3.4.1.min.js"
        integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous">
    </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"
        integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous">
    </script>
    <script type="text/javascript" charset="utf8" src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.js">
    </script>

    {{-- <!-- Your custom styles (optional) -->
    <link rel="stylesheet" href="{{ asset('mdb/css/style.css') }}"> --}}
</head>

<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}"
                    style="color:#45b3e7; text-transform:uppercase; font-weight:bold;">
                    {{ config('app.name', 'Datatables') }}
                </a>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">
                    </ul>


                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('datatable1') }}">{{ __('Datatable 1') }}</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('datatable2') }}">{{ __('Datatable 2') }}</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('datatable3') }}">{{ __('Datatable 3') }}</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>


</body>

</html>

resources/views/show.blade.php
@extends('layouts.app')

@section('content')
<div class="card" style="width: 18rem;">
    <div class="card-header">
        {{ $post['id'] }} - {{ $post['title'] }}
    </div>
    <ul class="list-group list-group-flush">
        <li class="list-group-item">{{ $post['body'] }}</li>
    </ul>
</div>
@endsection